<template>
    <div>
        <div
            class="row mt-4"
        >
            <div
                v-for="(plan, index) in plans"
                :key="index"
                class="col-xl-3 col-lg-4 col-md-6"
            >
                <div class="plan-container">
                    <StickerTop
                        v-if="plan.top"
                        text="top"
                        :position="{ right: 23, top: 19, rotate: 37 }"
                    />
                    <div class="plan-header-container">
                        <div class="plan-header-title">
                            {{ plan.title }}
                        </div>
                    </div>
                    <div class="plan-body-container">
                        <ul>
                            <li
                                v-for="(feature, index) in plan.features"
                                :key="index"
                            >
                                {{ feature }}
                            </li>
                            <div class="li-text">
                                (one time credit)
                            </div>
                        </ul>
                        <div class="action-button-container">
                            <button
                                v-if="
                                    isPlan(plan.title.toLocaleLowerCase())
                                "
                                class="btn current-plan"
                                type="button"
                                disabled
                            >
                                Current Plan
                            </button>
                            <!-- {{activePlanId}} -->
                            <button
                                v-else
                                :class="[
                                    { 'loading-xs': plan.loading },
                                    { 'hide-button': plan.id < activePlanId },
                                    { 'current-plan': plan.loading },
                                ]"
                                class="btn blue-btn"
                                :disabled="plan.loading"
                                @click="selectLogic(plan)"
                            >
                                {{ plan.loading === false ? "Select Plan" : "" }}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <ModalFreePlan
            :show="showModalConfirm"
            @close="closeModalConfirm()"
            @confirm="selectPlanLogic('beginner')"
            @cancel="selectPlanLogic('free')"
        />
        <ModalDiscount
            :show="showModalDiscount"
            @close="closeModalDiscount()"
            @confirm="selectPlanLogic('beginner', 'beginner-20-off')"
            @cancel="selectPlanLogic('free')"
        />
    </div>
</template>

<script>
import pricing from "@/mixins/pricing/pricing.service";
import shop from "@/mixins/shop.service";
import { plansWix } from "@/store/constants.js";
import abTesting from "@/mixins/ab-testing/index.js";
import StickerTop from "@/components/testing-elements/pricing/StickerTop";
import ModalFreePlan from "@/components/testing-elements/pricing/ModalFreePlan";
import ModalDiscount from "@/components/testing-elements/pricing/ModalDiscount";

export default {
  components: {
    StickerTop,
    ModalFreePlan,
    ModalDiscount,
  },
  mixins: [pricing, shop, abTesting],
  props: ['balance'],
  data() {
    return {
      plans: plansWix,
      showModalDiscount: false,
      loading: false,
      activePlanId: 0,
      shop: null,
      showModalConfirm: false,
      selectedPlan: null,
    };
  },
    async created() {
        await this.loadShop()
        this.startABTesting()
    },
    methods: {
    isPlan(title) {
      if (title === "free") {
        title = "basic";
      }
      const plan = this.shop && this.shop.plan && this.shop.plan.toLowerCase();
      return title === plan;
    },
    async loadShop() {
      const res = await this.getShop();
      this.shop = res;
      this.getActiveId()
    },
    getItem(title) {
      return this.plans.find(el => el.title.toLowerCase() == title)
    },
    getActiveId() {
      const item = this.plans.find(el => el.title.toLowerCase() == this.shop.plan)
      if(item) this.activePlanId = item.id
    },
    selectLogic(plan) {
      this.selectedPlan = plan;
      const isPlanFree = plan.title.toLowerCase() == 'free'
      if (this.needConfirm && isPlanFree) {
        this.showModalConfirm = true;
      } else if (this.needDiscount && isPlanFree) {
        this.showModalDiscount = true;
        // this.needDiscount += 1;
      } else {
        this.selectedPlan.loading = true
        this.$emit('confirm', {
          selectedPlan :this.selectedPlan,
          title: this.selectedPlan.title.toLowerCase(),
        })
      }
    },
    closeModalConfirm() {
      this.showModalConfirm = false
      this.removeSelectedPlan()
    },
    selectPlanLogic(title, url) {
      this.$emit('confirm', {
        selectedPlan: this.getItem(title), title, url
      }) 
      this.closeModalDiscount()
    },
    closeModalDiscount() {
      this.showModalDiscount = false
      this.removeSelectedPlan()
    },
    removeSelectedPlan() {
      if(this.selectedPlan) {
        this.selectedPlan.loading = false
        this.selectedPlan = null
      }
    }
  },
};
</script>


<style scoped lang="scss">
@import "resources/css/colors";

.current-plan {
  width: 100%;
  padding: 10px 20px;
  font-weight: bold;
  border-radius: 5px;
  font-size: 14px;
  border-color: #c1c1c1 !important;
  color: white;
  background: #c1c1c1;

  &:hover {
    background: #c1c1c1 !important;
    border-color: #c1c1c1 !important;
    color: white;
    text-decoration: none;
  }
}
.btn {
  display: flex;
  align-items: center;
  justify-content: center;
}
.plan-header-title {
  font-weight: 600;
}

.plan-body-container {
  height: 200px;
  padding-top: 15px;
  padding-bottom: 15px;
}

.blue-btn {
  width: 100%;
}

.add-btn {
  color: $blue-color;
  font-weight: 600;
  
}

.plan-container {
  background: white;
  border-radius: 5px;
  margin-bottom: 20px;
    background: white;
    border-radius: 5px;
    margin: 5px;
    border: 1px solid #eeeff0;
}
.plan-header-container {
  padding: 15px 20px;
  border-bottom: 1px solid #eeeff0;
}
.action-button-container {
  margin: 17px 30px;
  display: flex;
  justify-content: center;
}
.plan-header-title {
  font-weight: 600;
}
.plan-body-container {
  height: 200px;
  padding-top: 15px;
  padding-bottom: 15px;
}


ul {
  list-style: none;
}

ul li {
  margin-bottom: 5px;
}

ul li::before {
  content: "●";
  color: $blue-color;
  font-weight: bold;
  display: inline-block;
  width: 1em;
  margin-left: -1em;
}

.li-text {
  font-size: 12px;
  color: #98a0a6;
}
.hide-button {
  display: none !important;
}
</style>